/* ***********************************************  */
/*   Projet  : Recherche de solution de l'Ane rouge */
/*   Date    : avril 2009                           */
/*   Auteur  : Climoo                               */
/*   Fichier : allocations.c                        */
/*   Description : Module charge de                 */
/*   l'allocation dynamique de la memoire           */
/*                                                  */
/* **************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "allocations.h"

void *allouer(size_t n){
  void *res = (void *)malloc(n);
  if (res == NULL){
    fprintf(stderr,"Erreur : allocation dynamique impossible\n");
    exit(1);
  }
  return res;
}

void *reallouer(void *adr, size_t n){
  void *res = (void *)realloc(adr,n);
  if (res == NULL){
    fprintf(stderr,"Erreur : allocation dynamique impossible\n");
    exit (1);
  }
  return res;
}

void *allouer0(size_t n){
  void *res = (void *)malloc(n);
  if (res == NULL){
    fprintf(stderr,"Erreur : allocation dynamique impossible\n");
    exit(1);
  }
  memset(res,0,n);
  return res;
}
