/* ***********************************************  */
/*   Projet  : Recherche de solution de l'Ane rouge */
/*   Date    : avril 2009                           */
/*   Auteur  : Climoo                               */
/*   Fichier : allocations.h                        */
/*   Description : En-tete du module charge de      */
/*   l'allocation dynamique de la memoire           */
/*                                                  */
/* **************************************************/

/*Alloue dynamiquement n octets.
Si l'allocation echoue, le programme sera quitte automatiquement
avec le code 1 (exit 1). (equivalent malloc)*/
void *allouer(size_t n);

/*Realloue dynamiquement n octets a partir de l'adresse adr
fournie en parametre. 
Si l'allocation echoue, le programme sera quitte automatiquement
avec le code 1 (exit 1). (equivalent realloc)*/
void *reallouer(void *adr, size_t n);

/* Alloue dynamiquement n octets. De plus, la zone
memoire est remplie avec la valeur 0.
Si l'allocation echoue, le programme sera quitte automatiquement
avec le code 1 (exit 1). (equivalent calloc).*/
void *allouer0(size_t n);
