/* ***********************************************  */
/*   Projet  : Recherche de solution de l'Ane rouge */
/*   Date    : avril 2009                           */
/*   Auteur  : Climoo                               */
/*   Fichier : fileT.c                              */
/*   Description : Module charge de                 */
/*   de gerer une file dynamique et generique       */
/*                                                  */
/* **************************************************/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "allocations.h"
#include "fileT.h"

void initialiserFile(File *f, int incr){
  if (incr <= 1){
    f->inc = DEFAUT_INCR_FILE;
    f->taille = DEFAUT_INCR_FILE;
  }
  else{
    f->inc = incr;
    f->taille = incr;
  }
  f->tete = -1;
  f->queue = 0;
  f->fl = (void **)allouer(sizeof(void*)*f->taille);
}

void enfiler(File *f, void *elt){
  if (estPleine(*f)){ /*Si la file est pleine, on ajoute de la place dynamiquement*/
    f->fl = (void **)reallouer(f->fl,sizeof(void*)*(f->taille + f->inc));
    memmove(f->fl + f->inc + f->tete  ,f->fl+f->tete, (f->taille - f->tete)*sizeof(void*) );
    f->tete += f->inc ;  /*Mise a jour de la tete*/
    f->taille += f->inc ;/*Mise a jour de la taille*/
  }
  else if (estVide(*f)) /*S'il s'agit de la premiere insertion*/
    f->tete = f->queue; /*La tete prend la valeur de la place a laquelle on va mettre l'element*/
  f->fl[f->queue] = elt ; /*Insertion a la queue de la file*/
  f->queue  = (f->queue +1) % f->taille;
}

void *defiler(File *f){
  void *res = f->fl[f->tete];
  f->tete = (f->tete +1) % f->taille; /*La tete est deplacee, de 1. Revient a 0 si on depasse la taille*/
  if (f->tete == f->queue){ /*Si la file est maintenant vide*/
    f->tete = -1; /*Mise a jour de la tete*/
    f->queue = 0; /*Mise a jour de la queue*/
  }
  return res;
}

void supprimerFile(File *f){
  free(f->fl);
}


