/* ***********************************************  */
/*   Projet  : Recherche de solution de l'Ane rouge */
/*   Date    : avril 2009                           */
/*   Auteur  : Climoo                               */
/*   Fichier : fileT.h                              */
/*   Description : En tete du module charge de      */
/*   de gerer une file dynamique et generique       */
/*                                                  */
/* **************************************************/


/*Structure d'une file, geree par un tableau*/
typedef struct {
  int tete;   /*Indice a partir duquel on defile les elements (suppression)*/
  int queue;  /*Indice a partir duquel on enfile les elements (insertion)*/
  int taille; /*La taille en memoire de la file (pas le nombre d'elements)*/
  int inc;    /*Increment pour la taille de la file si manque de place*/
  void **fl;  /*Le tableau de pointeur generique*/
} File;

/*Taille de la file par defaut. Si la place manque dans la file,
  par defaut, on va augmenter la taille de la file de cette valeur.*/
#define DEFAUT_INCR_FILE 1024

/*Fonction permettant d'initialiser la file. La valeur incr est la taille
 de l'increment par defaut. S'il est inferieur a 1, la valeur DEFAUT_INCR_FILE
 est utilisee.*/
void initialiserFile(File *f, int incr);

/*Macro permettant de tester si la file est vide ou non (retourne 1 si oui, 0 sinon)*/
#define estVide(f) ((f).tete == -1)

/*Macro permettant de tester si la file est pleine ou non (retourne 1 si oui, 0 sinon)*/
/*Remarque : Si la file est pleine, cela n'empeche pas l'insertion, car la taille de la
 file sera augmentee.*/
#define estPleine(f) ((f).queue == (f).tete)

/*Fonction permettant d'enfiler un element dans la file f*/
void enfiler(File *f, void *elt);

/*Fonction permettant de defiler un element de f.
  Attention : La file ne doit pas etre vide : pas de test effectue.*/
void *defiler(File *f);
  
/*Fonction permettant de liberer la memoire utilisee par la file.*/
void supprimerFile(File *f);
