/* ***********************************************  */
/*   Projet  : Recherche de solution de l'Ane rouge */
/*   Date    : avril 2009                           */
/*   Auteur  : Climoo                               */
/*   Fichier : kl_deplacements.h                    */
/*   Description : Module charge de                 */
/*   de tous les affichages du jeu : situation      */
/*   du jeu et affichage d'une solution             */
/*                                                  */
/* **************************************************/

#include <stdio.h>
#include "kl_definitions.h"
#include "kl_affichage.h"

/*Macro permettant de decaler l'affichage*/
#define afficherDecalage() (printf("\t\t"))

/*Constante pour le nombre de colonnes pour l'affichage de la situation.
  NB_COL de deplacements.*/
#define NB_COL 3

void afficherPlateau(KL_Situation *kl){
  int i = 0;
  KL_Piece pie;
  printf("Affichage du jeu :\n\n");
  afficherDecalage();
  while( i < KL_SURFACE){
    pie = getCase(*kl,i);
    if (estCaracVide(pie))
      putchar(' ');
    else
      putchar(pie);
    if (getIndDroite(i) == -1){
      putchar('\n');
      afficherDecalage();
    }
    i++;
  }
  putchar('\n');
  return ;
}

void afficherSolution(KL_Solution *sol){
  int i = (sol->nbmvts) - 1;
  unsigned char cpt = 0;
  if (sol->nbmvts == -1) /*-1 :Valeur arbitraire pour indiquee qu'il n'y a pas de solution*/
    printf("Aucune solution trouvee");
  else{
    printf("Solution trouvee : %d mouvements.\n", sol->nbmvts);
    while (i >= 0){ /*Premier deplacement a l'indice (nbmvts -1)*/
      printf("Piece %c : ", sol->mvts[i].pie);
      switch(sol->mvts[i].dir){
      case BAS:    printf("Bas    "); break;
      case HAUT:   printf("Haut   "); break;
      case DROITE: printf("Droite "); break;
      case GAUCHE: printf("Gauche "); break;
      default :    printf("   ?   ");
      }
      i--;
      cpt = (cpt + 1) %3;
      if ( cpt% NB_COL == 0)
	putchar('\n');
      else
	putchar('\t');
   
    }
  }
  putchar('\n');
}

